import { parse, stringify } from 'css';

function getNodes(node, nodes) {
  if (nodes === void 0) {
    nodes = [];
  }

  function _ref(child) {
    return getNodes(child, nodes);
  }

  if (node.children) {
    node.children.forEach(_ref);
  }

  function _ref2(child) {
    return getNodes(child, nodes);
  }

  if (Array.isArray(node)) {
    node.forEach(_ref2);
  } else if (typeof node === 'object') {
    nodes.push(node);
  }

  return nodes;
}

function _ref3(node) {
  node.withNewStyles = true;
}

function markNodes(nodes) {
  nodes.forEach(_ref3);
}

var clsPattern = /css-([a-zA-Z0-9-]+)/gi;
var serializer = {
  test: function test(val) {
    if (!val) {
      return false;
    }

    if (!val.withNewStyles && val.$$typeof === Symbol.for('react.test.json')) {
      return true;
    } else if (Array.isArray(val) && !val[0].withNewStyles && val[0].$$typeof === Symbol.for('react.test.json')) {
      return true;
    }

    return false;
  },
  print: function print(val, printer) {
    var nodes = getNodes(val);
    markNodes(nodes);
    var i = 0;
    var classMap = {};

    function _ref4(match, p1) {
      if (classMap[p1] === undefined) {
        classMap[p1] = "emotion-" + i++;
      }

      return classMap[p1];
    }

    nodes.forEach(function (node) {
      if (typeof node.props['data-more'] === 'string') {
        try {
          var replaced = node.props.dangerouslySetInnerHTML.__html.replace(clsPattern, _ref4); // split the string by line to get correct indentation


          node.children = stringify(parse(replaced)).split('\n');
        } catch (e) {
          throw new Error("Error parsing css: " + node.props.dangerouslySetInnerHTML.__html);
        }

        delete node.props['data-more'];
        delete node.props.dangerouslySetInnerHTML;
      }
    });

    function _ref5(match, p1) {
      if (classMap[p1] !== undefined) {
        return classMap[p1];
      }

      return match;
    }

    nodes.forEach(function (node) {
      if (typeof node.props.className === 'string') {
        node.props.className = node.props.className.replace(clsPattern, _ref5);
      }
    });
    return printer(val);
  }
};

export { serializer };
//# sourceMappingURL=index.es.js.map
